#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>

#include "udm_config.h"
#include "udm_common.h"
#include "udm_utils.h"
#include "udm_section.h"


void UdmSectionFree(UDM_SECTION * S){
	UDM_FREE(S->name);
	return;
}

void UdmSectionListFree(UDM_SECTIONLIST * Lst){
	size_t i;
	
	for(i=0;i<Lst->nsec;i++){
		UdmSectionFree(&Lst->Sections[i]);
	}
	UDM_FREE(Lst->Sections);
	bzero(Lst,sizeof(*Lst));
	return;
}

void UdmSectionListAdd(UDM_SECTIONLIST * Lst,UDM_SECTION * S){
	
	Lst->Sections=(UDM_SECTION*)realloc(Lst->Sections,(Lst->nsec+1)*sizeof(*Lst->Sections));
	bzero(&Lst->Sections[Lst->nsec],sizeof(*Lst->Sections));
	Lst->Sections[Lst->nsec].type=S->type;
	Lst->Sections[Lst->nsec].section=S->section;
	Lst->Sections[Lst->nsec].fieldlen=S->fieldlen;
	Lst->Sections[Lst->nsec].name=strdup(S->name);
	Lst->Sections[Lst->nsec].field=S->field?strdup(S->field):NULL;
	Lst->nsec++;
	return;
}

UDM_SECTION * UdmSectionListFind(UDM_SECTIONLIST * L,const char * name){
	size_t i;
	
	for(i=0;i<L->nsec;i++)
		if(!strcasecmp(L->Sections[i].name,name))
			return(&L->Sections[i]);
	return NULL;
}
